
# MLH Localhost: Bug-free coding with SPARK Ada

Welcome to MLH Localhost: Bug-free coding with SPARK Ada!  This USB Flash Drive
includes all the files you need for this workshop.  Follow the instructions
below to copy the sample code to your computer and install Ada and SPARK.

Looking for the workshop page? [Click Here!][1]

## Getting Started

There are two ways to get the install files and sample code for this workshop.  Select the option that best fits your situation below:

 - [**Install from USB Flash Drive**](#installing-from-usb) - Select this option if you are at a workshop which has USB Flash Drives with the software already on them.
 - [**Download the Software**](#installing-from-the-web) - Select this option if you do not have access to a physical USB Flash Drive with the software already on it.

## [Installing from USB](#installing-from-usb)

Some workshops have physical USB Flash Drives that contain the installation files.  If you are at a workshop with USB devices and have one in your posession, follow these instructions.

Here is a description of the files included on the USB Flash Drive:

 - `adacore-linux-v1.0.0.zip` - Zipped install files for Linux.
 - `adacore-mac-v1.0.0.zip` - Zipped install files for MacOS.
 - `adacore-windows-v1.0.0.zip` - Zipped install files for Windows.
 - `README.md` - This README file, which includes install instructions.
 - `sample-code/` - A directory containing the sample code for this workshop.

### Step 1: Copy the sample code to your computer

Start by copying the `sample-code/` directory from the USB Flash Drive to your
computer.  This contains the source code for the example we'll work through
during the workshop.

### Step 2: Copy the install files for your operating system

The USB Flash Drive contains a Zip archive with the installation files for
Linux, Mac, and Windows operating systems.  Copy the file corresponding to your
computer's operating system to your computer.

### Step 3: Unzip the install file archive

Extract the files from the compressed zip archive that you copied over to your
computer.  Most operating systems include a built in tool to do this, but you
can also use one that you download from the Internet.

### Step 4: Install GNAT and SPARK (Windows Only!)

**Info**: This step is only relevant to Windows users.  If you are using a Mac
or Linux computer, skip ahead to Step 5.

Inside the extracted archive, there are two executable files:

 - `install-gnat-gpl-2017.exe` - This will install GNAT and GPS.
 - `install-spark-gpl-2017.exe` - This install the SPARK tool set.

You'll need to install **both** of these programs.  Using the default settings
and install locations is fine.  This should take 3 - 7 minutes total.

### Step 5: Start GNAT Programming Studio (GPS)

The final step is to start the GPS IDE.  This is slightly different between
Windows and Mac/Linux.

#### Windows

Navigate to `Start > Programs > GNAT > GPS` or just type `GPS` in the finder and
run the application when it comes up.

#### Mac / Linux

The extracted archive contains a file called `gps`.  Double click this file to
start the program.

## [Installing from the Web](#installing-from-the-web)

You can easily download all of the software you need for this workshop from the Internet.  **Warning**: These files are quite large (~500MB).  It is recommended you download these files ___before___ the workshop because it can take a long time depending on your connection. 

### Step 1: Download the sample code

Start by downloading the sample code for this workshop.  The file is a compressed Zip archive conatining the source code for the example we'll work through during the workshop.

**Download the Source**: [Direct Download][2] | [GitHub Repo][3]

### Step 2: Download the install files for your operating system

Next you'll need to download the zip archive with the installation files for your computer's operating system.  There are zip archives for Linux, Mac, and Windows operating systems.  

 - [Linux Download][4]
 - [Mac Download][5]
 - [Windows Download][6]

### Step 3: Unzip the install file archive & sample code

Extract the files from the compressed zip archives that you just finished downloading to your
computer.  Most operating systems include a built in tool to do this, but you can also use one that you download from the Internet.

### Step 4: Install GNAT and SPARK (Windows Only!)

**Info**: This step is only relevant to Windows users.  If you are using a Mac
or Linux computer, skip ahead to Step 5.

Inside the extracted archive, there are two executable files:

 - `install-gnat-gpl-2017.exe` - This will install GNAT and GPS.
 - `install-spark-gpl-2017.exe` - This install the SPARK tool set.

You'll need to install **both** of these programs.  Using the default settings
and install locations is fine.  This should take 3 - 7 minutes total.

### Step 5: Start GNAT Programming Studio (GPS)

The final step is to start the GPS IDE.  This is slightly different between
Windows and Mac/Linux.

#### Windows

Navigate to `Start > Programs > GNAT > GPS` or just type `GPS` in the finder and
run the application when it comes up.

#### Mac / Linux

The extracted archive contains a file called `gps`.  Double click this file to
start the program.

[1]: https://localhost.mlh.io/activities/intro-to-sparkada/
[2]: https://github.com/MLH/mlh-localhost-adacore/archive/master.zip
[3]: https://github.com/MLH/mlh-localhost-adacore
[4]: http://hackp.ac/adacore-linux
[5]: http://hackp.ac/adacore-mac
[6]: http://hackp.ac/adacore-windows

